	include "gentables.asm"

	align 256
	; aligned memory start
tableSizeStart
rorTables 
	ds.b $100,$00  ; incbin "rortable_2.bin"
shr4table
	ds.b $100,$00  ; incbin "rortable_4.bin"
	ds.b $100,$00  ; incbin "rortable_6.bin"
rorTablesFillup
	ds.b $100,$00  ; incbin "rortable_2_f.bin"
	ds.b $100,$00  ; incbin "rortable_4_f.bin"
	ds.b $100,$00  ; incbin "rortable_6_f.bin"
aslTables 
	ds.b $100,$00  ; incbin "asltable_6.bin"
shl4table
	ds.b $100,$00  ; incbin "asltable_4.bin"
	ds.b $100,$00  ; incbin "asltable_2.bin"
aslTablesFillup
	ds.b $100,$00  ; incbin "asltable_6_f.bin"
	ds.b $100,$00  ; incbin "asltable_4_f.bin"
	ds.b $100,$00  ; incbin "asltable_2_f.bin"
xfliptable
	ds.b $100,$00  ; incbin "xfliptable.bin"
MUL8TABLO
	ds.b $100,$00  ; REPEAT
MUL8TABHI
	ds.b $100,$00  ; REPEAT
automask
	ds.b $100,$00  ; incbin "automask.bin"
	; aligned memory end
MUL40TABLO
Y SET 0
	REPEAT SCREENROWS*2
	dc.b <[[Y % SCREENROWS]*40]
Y SET Y + 1
	REPEND 
MUL40TABHI
Y SET 0
	REPEAT SCREENROWS*2
	dc.b >[[Y % SCREENROWS]*40]
Y SET Y + 1
	REPEND 
tableSizeEnd


genTables SUBROUTINE
	lda #$00
	sta ZP_PROCEDURETEMP + 1
	sta ZP_PROCEDURETEMP + 2
	ldx #$00
.again

	txa
	lsr
	lsr
	sta rorTables+$100*0,x
	ora #%11000000
	sta rorTablesFillup + $100*0,x
	txa
	lsr
	lsr
	lsr
	lsr
	sta rorTables+$100*1,x
	ora #%11110000
	sta rorTablesFillup + $100*1,x
	txa
	lsr
	lsr
	lsr
	lsr
	lsr
	lsr
	sta rorTables+$100*2,x
	ora #%11111100
	sta rorTablesFillup + $100*2,x

	txa
	asl
	asl
	asl
	asl
	asl
	asl
	sta aslTables+$100*0,x
	ora #%00111111
	sta aslTablesFillup + $100*0,x
	txa
	asl
	asl
	asl
	asl
	sta aslTables+$100*1,x
	ora #%00001111
	sta aslTablesFillup + $100*1,x
	txa
	asl
	asl
	sta aslTables+$100*2,x
	ora #%00000011
	sta aslTablesFillup + $100*2,x

	txa
	asl
	asl
	asl
	asl
	asl
	asl
	sta ZP_PROCEDURETEMP
	txa
	lsr
	lsr
	lsr
	lsr
	lsr
	lsr
	ora ZP_PROCEDURETEMP
	sta ZP_PROCEDURETEMP
	txa
	asl
	asl
	and #%00110000
	ora ZP_PROCEDURETEMP
	sta ZP_PROCEDURETEMP
	txa
	lsr
	lsr
	and #%00001100
	ora ZP_PROCEDURETEMP
	sta xfliptable,x

	lda ZP_PROCEDURETEMP + 1
	sta MUL8TABLO,x
	clc
	adc #<$08
	sta ZP_PROCEDURETEMP + 1
	lda ZP_PROCEDURETEMP + 2
	sta MUL8TABHI,x
	adc #>$08
	sta ZP_PROCEDURETEMP + 2

	lda #$00
	sta ZP_PROCEDURETEMP + 3
	lda #%00000011
	sta ZP_PROCEDURETEMP + 4
.mask
	txa
	and ZP_PROCEDURETEMP + 4
	cmp ZP_PROCEDURETEMP + 4
	beq .zero1
	ora ZP_PROCEDURETEMP + 3
	sta ZP_PROCEDURETEMP + 3
.zero1
	asl ZP_PROCEDURETEMP + 4
	asl ZP_PROCEDURETEMP + 4
	bne .mask
	lda ZP_PROCEDURETEMP + 3
	sta automask,x

	inx
	beq .done
	jmp .again
.done
	rts
